import org.lwjgl.opengl.GL11;

public class World {
    private int blocks[][][];
    private int blockBuffer[][];
    private static int XMAX=40, YMAX=20, ZMAX=40;
    public static int dirt = 1, air = 0, stone = 2;
    private int blockCount;
    private Block dirtBlock, stoneBlock;
    private int worldRenderList;
    

    public void addBlock(int x, int y,  int z, int type){
       blocks[x][y][z] = type; 
    }
    public void removeBlock(int x, int y, int z){
        
        
    }

    public void refreshBuffer(){
        int cnt = 0;
           for(int j = 0; j < XMAX; j++){
               for(int k = 0; k<YMAX; k++){
                   for(int l =0; l<ZMAX; l++){
                    if(blocks[j][k][l] != World.air) cnt++;    
                   }
               }
            }
       System.out.println("Block count: "+cnt);
       blockBuffer = new int[cnt][4];
       int m = 0;
           for(int j = 0; j < XMAX; j++){
               for(int k = 0; k<YMAX; k++){
                   for(int l =0; l<ZMAX; l++){
                       if(blocks[j][k][l] != World.air){
                           switch(blocks[j][k][l]){
                                case 1:
                                    blockBuffer[m][3]=World.dirt;
                                    break; 
                                case 2:
                                    blockBuffer[m][3]=World.stone;
                                    break;
                           }

                           blockBuffer[m][0] = j;
                           blockBuffer[m][1] = k;
                           blockBuffer[m][2] = l;
                           m++;
                           //System.out.println("Block #"+m+": X="+j+" Y="+k+" Z="+l);
                       }

                   }
               }         
       }
      blockCount = cnt;

    }
    
    public void populateGround(){
       int i = 0, j=0;
        while(i < XMAX){
            while(j < ZMAX){
                blocks[i][YMAX-1][j] = 1;
             j++;
            }
            i++;
            j=0;
        }
    }
    
    public void generateWorldRenderList(){
        worldRenderList = GL11.glGenLists(1);
        GL11.glNewList(worldRenderList, GL11.GL_COMPILE);
        int i = 0;
        while(i < blockCount){
            switch(blockBuffer[i][3]){
                  case 1:
                      dirtBlock.setPos(blockBuffer[i][0]*400f, blockBuffer[i][1]*400f, blockBuffer[i][2]*400f);
                      dirtBlock.render();
                      break;
                  case 2:
                      stoneBlock.setPos(blockBuffer[i][0]*400f, blockBuffer[i][1]*400f, blockBuffer[i][2]*400f);
                      stoneBlock.render();
                      break;

            }

            i++;
        }
        GL11.glEndList();
    }
            


    public void render(){
        GL11.glCallList(worldRenderList);
    }

    World(){
      blocks = new int[XMAX][YMAX][ZMAX];
      dirtBlock = new Block(true);
      stoneBlock = new Block(true);
      stoneBlock.setType(Block.stone);


    }
}
